"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Answer_1 = require("./Answer");
const ClosedDetails_1 = require("./ClosedDetails");
const Comment_1 = require("./Comment");
const MigrationInfo_1 = require("./MigrationInfo");
const Notice_1 = require("./Notice");
const ShallowUser_1 = require("./ShallowUser");
class Question {
    constructor(question) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
        this.acceptedAnswerId = (_a = question.accepted_answer_id, (_a !== null && _a !== void 0 ? _a : null));
        this.answerCount = question.answer_count;
        if (typeof question.answers === 'undefined') {
            this.answers = null;
        }
        else {
            this.answers = question.answers
                .map((answer) => new Answer_1.Answer(answer));
        }
        this.body = (_b = question.body, (_b !== null && _b !== void 0 ? _b : null));
        this.bodyMarkdown = (_c = question.body_markdown, (_c !== null && _c !== void 0 ? _c : null));
        this.bountyAmount = (_d = question.bounty_amount, (_d !== null && _d !== void 0 ? _d : null));
        this.bountyClosesDate = (_e = question.bounty_closes_date, (_e !== null && _e !== void 0 ? _e : null));
        if (typeof question.bounty_user === 'undefined') {
            this.bountyUser = null;
        }
        else {
            this.bountyUser = new ShallowUser_1.ShallowUser(question.bounty_user);
        }
        this.canClose = (_f = question.can_close, (_f !== null && _f !== void 0 ? _f : null));
        this.canFlag = (_g = question.can_flag, (_g !== null && _g !== void 0 ? _g : null));
        this.closeVoteCount = (_h = question.close_vote_count, (_h !== null && _h !== void 0 ? _h : null));
        this.closedDate = (_j = question.closed_date, (_j !== null && _j !== void 0 ? _j : null));
        if (typeof question.closed_details === 'undefined') {
            this.closedDetails = null;
        }
        else {
            this.closedDetails = new ClosedDetails_1.ClosedDetails(question.closed_details);
        }
        this.closedReason = (_k = question.closed_reason, (_k !== null && _k !== void 0 ? _k : null));
        this.commentCount = (_l = question.comment_count, (_l !== null && _l !== void 0 ? _l : null));
        if (typeof ((_m = question) === null || _m === void 0 ? void 0 : _m.comments) === 'undefined') {
            this.comments = null;
        }
        else {
            this.comments = question.comments
                .map((comment) => new Comment_1.Comment(comment));
        }
        this.communityOwnedDate = (_o = question.community_owned_date, (_o !== null && _o !== void 0 ? _o : null));
        this.creationDate = question.creation_date;
        this.deleteVoteCount = (_p = question.delete_vote_count, (_p !== null && _p !== void 0 ? _p : null));
        this.downVoteCount = (_q = question.down_vote_count, (_q !== null && _q !== void 0 ? _q : null));
        this.downvoted = (_r = question.downvoted, (_r !== null && _r !== void 0 ? _r : null));
        this.favoriteCount = (_s = question.favorite_count, (_s !== null && _s !== void 0 ? _s : null));
        this.favorited = (_t = question.favorited, (_t !== null && _t !== void 0 ? _t : null));
        this.isAnswered = question.is_answered;
        this.lastActivityDate = question.last_activity_date;
        this.lastEditDate = (_u = question.last_edit_date, (_u !== null && _u !== void 0 ? _u : null));
        if (typeof question.last_editor === 'undefined') {
            this.lastEditor = null;
        }
        else {
            this.lastEditor = new ShallowUser_1.ShallowUser(question.last_editor);
        }
        this.link = question.link;
        this.lockedDate = (_v = question.locked_date, (_v !== null && _v !== void 0 ? _v : null));
        if (typeof question.migrated_from === 'undefined') {
            this.migratedFrom = null;
        }
        else {
            this.migratedFrom = new MigrationInfo_1.MigrationInfo(question.migrated_from);
        }
        if (typeof question.migrated_to === 'undefined') {
            this.migratedTo = null;
        }
        else {
            this.migratedTo = new MigrationInfo_1.MigrationInfo(question.migrated_to);
        }
        if (typeof question.notice === 'undefined') {
            this.notice = null;
        }
        else {
            this.notice = new Notice_1.Notice(question.notice);
        }
        if (typeof question.owner === 'undefined') {
            this.owner = null;
        }
        else {
            this.owner = new ShallowUser_1.ShallowUser(question.owner);
        }
        this.protectedDate = (_w = question.protected_date, (_w !== null && _w !== void 0 ? _w : null));
        this.questionId = question.question_id;
        this.reopenVoteCount = (_x = question.reopen_vote_count, (_x !== null && _x !== void 0 ? _x : null));
        this.score = question.score;
        this.shareLink = (_y = question.share_link, (_y !== null && _y !== void 0 ? _y : null));
        this.tags = question.tags;
        this.title = question.title;
        this.upVoteCount = (_z = question.up_vote_count, (_z !== null && _z !== void 0 ? _z : null));
        this.upvoted = (_0 = question.upvoted, (_0 !== null && _0 !== void 0 ? _0 : null));
        this.viewCount = question.view_count;
    }
}
exports.Question = Question;
